/*
Duotas dvikryptis sąrašas, kuriame skaičiai gali kartotis.
Sukurti vienkryptį sąrašą į kurį pakliūna tik nepasikartojantys skaičiai

*/

#include <stdio.h>
#include <stdlib.h>


typedef struct sarasas_t Sarasas;
typedef struct dvikryptis_sarasas_t DvikryptisSarasas;

struct dvikryptis_sarasas_t
{
  int skaicius;
  DvikryptisSarasas *ankstesnis, *kitas;
};

struct sarasas_t
{
  int skaicius;
  Sarasas *kitas;
};

// --------------------------------------------

//
// iterpti elementa i dvikrypti sarasa
//
void dk_iterpti(DvikryptisSarasas **sar, int skaicius)
{
   // Jeigu sarasas yra tuscias
  if(*sar==NULL)
    {
       *sar=(DvikryptisSarasas*)malloc(sizeof(DvikryptisSarasas));
       (*sar)->ankstesnis=NULL;
       (*sar)->kitas=NULL;
       (*sar)->skaicius=skaicius;
       return;
    }

  DvikryptisSarasas *tmp=(DvikryptisSarasas*)malloc(sizeof(DvikryptisSarasas));
  tmp->skaicius=skaicius;

  tmp->ankstesnis=*sar;
  tmp->kitas=NULL;
  (*sar)->kitas=tmp;

  *sar=(*sar)->kitas;

}

// Atspausdinti dvikrypti sarasa
void dk_atspausdinti(DvikryptisSarasas *dk)
{
  while(dk->ankstesnis!=NULL)
      dk=dk->ankstesnis;

  while(dk!=NULL)
    {
       printf("%d ",dk->skaicius);
       dk=dk->kitas;
    }
}

// -------------------------------

//
// Iterpti i vienkrypti sarasa
//
void vk_iterpti(Sarasas **sar, int skaicius)
{
   // Jeigu sarasas yra tuscias
  if(*sar==NULL)
    {
       *sar=(Sarasas*)malloc(sizeof(Sarasas));
       (*sar)->kitas=NULL;
       (*sar)->skaicius=skaicius;
       return;
    }

  Sarasas *tmp=(Sarasas*)malloc(sizeof(DvikryptisSarasas));

  tmp->skaicius=skaicius;
  tmp->kitas=*sar;
  *sar=tmp;

}



// Atspausdinti vienkrypti sarasa
void vk_atspausdinti(Sarasas *sar)
{
  while(sar!=NULL)
    {
       printf("%d ",sar->skaicius);
       sar=sar->kitas;
    }
}

//
// Ieskoti elemento vienkrypciame sarase
// retval: 1-rasta, 0-nerasta
int vk_rasti(Sarasas *sar, int skaicius)
{
  int rasta=0;
  while(sar!=NULL)
    {
       if(skaicius==sar->skaicius)
           rasta=1;
        sar=sar->kitas;
    }
  return rasta;
}



//
// Konvertuoti dvikrypti sarasa i vienkrypti sarasa
//
Sarasas *konvertuoti(DvikryptisSarasas *dk_sar)
{
  while(dk_sar->ankstesnis!=NULL)
      dk_sar=dk_sar->ankstesnis;

  DvikryptisSarasas *p=dk_sar;
  Sarasas *tmp=NULL;

  while(p!=NULL)
    {
       if(vk_rasti(tmp,p->skaicius)==0)
           vk_iterpti(&tmp,p->skaicius);
       p=p->kitas;
    }

  return tmp;
}


int main()
{
    DvikryptisSarasas *dk_sar=NULL;
    int n=1;

    printf("Ivekite skaicius i dvikrypti sarasa (0 kad baigti):\n ");
    while(1)
      {
          scanf("%d",&n);
          if(n==0)
              break;
          dk_iterpti(&dk_sar,n);
      };

    printf("\nDvikryptis sarasas atrodo taip:\n ");
    dk_atspausdinti(dk_sar);

    Sarasas *sar=konvertuoti(dk_sar);
    printf("\nVienkryptis sarasas atrodo taip:\n ");
    vk_atspausdinti(sar);



    return 0;
}
